"""Add Workflow, WorkflowVersion and WorkflowExecution

Revision ID: 47d1ffbbfc92
Revises: d557b4b44b7c
Create Date: 2023-01-18 14:00:23.580468

"""

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import mysql

# revision identifiers, used by Alembic.
revision = "47d1ffbbfc92"
down_revision = "d557b4b44b7c"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "workflow",
        sa.Column("created_at", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.Column(
            "updated_at",
            sa.Integer(),
            server_default=sa.text("(UNIX_TIMESTAMP())"),
            nullable=False,
        ),
        sa.Column("workflow_id", sa.BINARY(length=16), server_default=sa.text("(UUID_TO_BIN(UUID()))"), nullable=False),
        sa.Column("name", sa.String(length=63), nullable=False),
        sa.Column("repository_url", mysql.TEXT(), nullable=False),
        sa.Column("short_description", mysql.TEXT(), nullable=False),
        sa.Column("developer_id", sa.String(length=64), nullable=True),
        sa.ForeignKeyConstraint(["developer_id"], ["user.uid"], ondelete="SET NULL"),
        sa.PrimaryKeyConstraint("workflow_id"),
        sa.UniqueConstraint("name"),
    )
    op.create_index(op.f("ix_workflow_workflow_id"), "workflow", ["workflow_id"], unique=True)
    op.create_table(
        "workflow_version",
        sa.Column("created_at", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.Column(
            "updated_at",
            sa.Integer(),
            server_default=sa.text("(UNIX_TIMESTAMP())"),
            nullable=False,
        ),
        sa.Column("git_commit_hash", sa.String(length=40), nullable=False),
        sa.Column("version", sa.String(length=10), nullable=False),
        sa.Column("published", sa.Boolean(), server_default="0", nullable=False),
        sa.Column("deprecated", sa.Boolean(), server_default="0", nullable=False),
        sa.Column("icon_slug", sa.String(length=48), nullable=True),
        sa.Column("workflow_id", sa.BINARY(length=16), nullable=False),
        sa.Column("previous_version_hash", sa.String(length=40), nullable=True),
        sa.ForeignKeyConstraint(
            ["previous_version_hash"],
            ["workflow_version.git_commit_hash"],
            ondelete="SET NULL",
        ),
        sa.ForeignKeyConstraint(["workflow_id"], ["workflow.workflow_id"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("git_commit_hash"),
    )
    op.create_index(op.f("ix_workflow_version_git_commit_hash"), "workflow_version", ["git_commit_hash"], unique=True)
    op.create_table(
        "workflow_execution",
        sa.Column("created_at", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.Column(
            "updated_at",
            sa.Integer(),
            server_default=sa.text("(UNIX_TIMESTAMP())"),
            nullable=False,
        ),
        sa.Column(
            "execution_id", sa.BINARY(length=16), server_default=sa.text("(UUID_TO_BIN(UUID()))"), nullable=False
        ),
        sa.Column("user_id", sa.String(length=64), nullable=False),
        sa.Column("workflow_version_id", sa.String(length=40), nullable=True),
        sa.Column("start_time", sa.Integer(), server_default=sa.text("(UNIX_TIMESTAMP())"), nullable=False),
        sa.Column("end_time", sa.Integer(), nullable=True),
        sa.Column(
            "status", mysql.ENUM("PENDING", "SCHEDULED", "RUNNING", "CANCELED", "SUCCESS", "ERROR"), nullable=False
        ),
        sa.Column("notes", mysql.TEXT(), nullable=True),
        sa.ForeignKeyConstraint(["user_id"], ["user.uid"], ondelete="CASCADE"),
        sa.ForeignKeyConstraint(["workflow_version_id"], ["workflow_version.git_commit_hash"], ondelete="SET NULL"),
        sa.PrimaryKeyConstraint("execution_id"),
    )
    op.create_index(op.f("ix_workflow_execution_execution_id"), "workflow_execution", ["execution_id"], unique=True)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f("ix_workflow_execution_execution_id"), table_name="workflow_execution")
    op.drop_table("workflow_execution")
    op.drop_index(op.f("ix_workflow_version_git_commit_hash"), table_name="workflow_version")
    op.drop_table("workflow_version")
    op.drop_index(op.f("ix_workflow_workflow_id"), table_name="workflow")
    op.drop_table("workflow")
    # ### end Alembic commands ###
